# StationViewWindow Struct Reference

The StationView window. More...

Inheritance diagram for StationViewWindow:

## Public Types
enum | AcceptListHeight { ALH_RATING = 13, ALH_ACCEPTS = 3 }
| Height of the SVW_ACCEPTLIST widget for different views. More...
## Public Member Functions
| StationViewWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
void | OrderWaitingCargo (CargoDataList *cargolist, uint32 *transfers)
| Order waiting cargo by type and destination.
void | DrawWaitingCargo (const Rect &r, const CargoDataList &cargolist, uint32 transfers) const
| Draw waiting cargo.
void | DrawAcceptedCargo (const Rect &r) const
| Draw accepted cargo in the SVW_ACCEPTLIST widget.
void | DrawCargoRatings (const Rect &r) const
| Draw cargo ratings in the SVW_ACCEPTLIST widget.
void | HandleCargoWaitingClick (int row)
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnResize ()
| Called after the window got resized.
## Data Fields
uint32 | cargo
| Bitmask of cargo types to expand.
uint16 | cargo_rows [NUM_CARGO]
| Header row for each cargo type.
uint | expand_shrink_width
| The width allocated to the expand/shrink 'button'.

## Detailed Description

The StationView window.

Definition at line 885 of file station_gui.cpp.

## Member Enumeration Documentation

enum StationViewWindow::AcceptListHeight

Height of the SVW_ACCEPTLIST widget for different views.

Enumerator:

  ALH_RATING | Height of the cargo ratings view.
  ALH_ACCEPTS | Height of the accepted cargo view.

Definition at line 891 of file station_gui.cpp.

## Member Function Documentation

virtual void StationViewWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 916 of file station_gui.cpp.

References ALH_ACCEPTS, ALH_RATING, expand_shrink_width, FONT_HEIGHT_NORMAL, GetStringBoundingBox(), Dimension::height, max(), SVW_ACCEPTLIST, SVW_ACCEPTS, SVW_WAITING, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, and Window::width.

virtual void StationViewWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 931 of file station_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, DrawWaitingCargo(), Window::DrawWidgets(), FACIL_AIRPORT, FACIL_BUS_STOP, FACIL_DOCK, FACIL_TRAIN, FACIL_TRUCK_STOP, BaseStation::facilities, SpecializedStation< Station, false >::Get(), Window::IsShaded(), OrderWaitingCargo(), BaseStation::owner, NWidgetBase::pos_x, NWidgetBase::pos_y, Scrollbar::SetCount(), Window::SetWidgetDisabledState(), SVW_PLANES, SVW_RENAME, SVW_ROADVEHS, SVW_SHIPS, SVW_TRAINS, SVW_WAITING, and Window::vscroll.

virtual void StationViewWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 956 of file station_gui.cpp.

References DrawAcceptedCargo(), DrawCargoRatings(), SVW_ACCEPTLIST, and SVW_ACCEPTS.

virtual void StationViewWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 967 of file station_gui.cpp.

References BaseStation::facilities, SpecializedStation< Station, false >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, SetDParam(), and SVW_CAPTION.

void StationViewWindow::OrderWaitingCargo | ( | CargoDataList * | cargolist,
|  | uint32 * | transfers |
| ) |  |  | `[inline]`

Order waiting cargo by type and destination.

Parameters:

  | cargolist | [out] Ordered cargo.
  | transfers | [out] Bitmask for cargoes being transfered.

Precondition:
  `*cargolist` must be empty.

Definition at line 981 of file station_gui.cpp.

References cargo, cargo_rows, CargoPacket::Count(), SpecializedStation< Station, false >::Get(), Station::goods, HasBit(), SetBit(), and CargoPacket::SourceStation().

Referenced by OnPaint().

void StationViewWindow::DrawWaitingCargo | ( | const Rect & | r,
|  | const CargoDataList & | cargolist,
|  | uint32 | transfers |
| ) |  |  | const`[inline]`

Draw waiting cargo.

Parameters:

  | r | Rectangle of the widget.
  | cargolist | Cargo, ordered by type and destination.
  | transfers | Bitmask for cargoes that are transfered.

Definition at line 1035 of file station_gui.cpp.

References _dynlang, cargo, DrawCargoIcons(), DrawString(), expand_shrink_width, FONT_HEIGHT_NORMAL, SpecializedStation< Station, false >::Get(), Scrollbar::GetCapacity(), Scrollbar::GetPosition(), Station::goods, HasBit(), Rect::left, Rect::right, SA_RIGHT, SetDParam(), TD_RTL, DynamicLanguages::text_dir, Rect::top, Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

Referenced by OnPaint().

void StationViewWindow::DrawAcceptedCargo | ( | const Rect & | r | ) | const`[inline]`

Draw accepted cargo in the SVW_ACCEPTLIST widget.

Parameters:

  | r | Rectangle of the widget.

Definition at line 1090 of file station_gui.cpp.

References Rect::bottom, DrawCargoListText(), SpecializedStation< Station, false >::Get(), Station::goods, HasBit(), Rect::left, Rect::right, SetBit(), Rect::top, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

Referenced by DrawWidget().

void StationViewWindow::DrawCargoRatings | ( | const Rect & | r | ) | const`[inline]`

Draw cargo ratings in the SVW_ACCEPTLIST widget.

Parameters:

  | r | Rectangle of the widget.

Definition at line 1105 of file station_gui.cpp.

References DrawString(), FONT_HEIGHT_NORMAL, SpecializedStation< Station, false >::Get(), Station::goods, HasBit(), CargoSpec::Index(), Rect::left, CargoSpec::name, Rect::right, SetDParam(), Rect::top, ToPercent8(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

Referenced by DrawWidget().

virtual void StationViewWindow::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 1139 of file station_gui.cpp.

References _ctrl_pressed, ALH_ACCEPTS, ALH_RATING, CS_ALPHANUMERAL, FONT_HEIGHT_NORMAL, SpecializedStation< Station, false >::Get(), MAX_LENGTH_STATION_NAME_BYTES, MAX_LENGTH_STATION_NAME_PIXELS, Window::owner, BaseStation::owner, OWNER_NONE, QSF_ENABLE_DEFAULT, Window::ReInit(), NWidgetCore::SetDataTip(), SetDParam(), ShowQueryString(), SVW_LOCATION, SVW_PLANES, SVW_RATINGS, SVW_RENAME, SVW_ROADVEHS, SVW_SHIPS, SVW_TRAINS, SVW_WAITING, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, WD_FRAMERECT_TOP, and Point::y.

virtual void StationViewWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string or NULL if the window was cancelled.

Reimplemented from Window.

Definition at line 1205 of file station_gui.cpp.

References CMD_MSG, CMD_RENAME_STATION, and DoCommandP().

virtual void StationViewWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1212 of file station_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), SVW_WAITING, Window::vscroll, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/station_gui.cpp